#
# spec file for package turing
#
# Copyright (c) 2020 SUSE LLC
# Copyright (c) 2018 Packman Team <packman@links2linux.de>
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%define _sover  0.0.0
%define _somaj  0
%define _lto_cflags %{nil}
Name:           turing
Version:        1.2.git.1499183039.72b085e
Release:        3.1
Summary:        H.265/HEVC video encoder/decoder
License:        GPL-2.0-only
Group:          Productivity/Multimedia/Video/Editors and Convertors
URL:            http://turingcodec.org/
Source0:        %{name}-%{version}.tar.xz
# PATCH-FIX-UPSTREAM turing-no-return-in-nonvoid.patch -- aloisio@gmx.com
Patch0:         turing-no-return-in-nonvoid.patch
# PATCH-FIX-OPENSUSE turing-system-boost.patch -- aloisio@gmx.com
Patch1:         turing-system-boost.patch
# PATCH-FIX-OPENSUSE turing-shared-libs.patch -- aloisio@gmx.com
Patch2:         turing-shared-libs.patch
BuildRequires:  cmake >= 2.8
BuildRequires:  gcc-c++
BuildRequires:  git
%if 0%{?suse_version} >= 1500
BuildRequires:  libboost_chrono-devel
BuildRequires:  libboost_filesystem-devel
BuildRequires:  libboost_program_options-devel
BuildRequires:  libboost_system-devel
BuildRequires:  libboost_timer-devel
%else
BuildRequires:  boost-devel
%endif
BuildRequires:  pkgconfig
ExclusiveArch:  x86_64

%description
The Turing codec is an H.265/HEVC software video encoder and decoder for efficient video compression.
The codec is optimised for fast encoding of large resolution video content while at the same time
preserving high perceptual qualities of the generated compressed video streams.

%package        devel
Summary:        Include files for the Turing codec
Group:          Development/Libraries/C and C++
Requires:       lib%{name}%{_somaj} = %{version}
Requires:       libhavoc%{_somaj} = %{version}

%description devel
This package provides the development header files for the Turing codec.

%package     -n libhavoc%{_somaj}
Summary:        H.265/HEVC video encoder/decoder
Group:          System/Libraries

%description -n libhavoc%{_somaj}
The Turing codec is an H.265/HEVC software video encoder and decoder for efficient video compression.
The codec is optimised for fast encoding of large resolution video content while at the same time
preserving high perceptual qualities of the generated compressed video streams.

%package     -n lib%{name}%{_somaj}
Summary:        H.265/HEVC video encoder/decoder
Group:          System/Libraries

%description -n lib%{name}%{_somaj}
The Turing codec is an H.265/HEVC software video encoder and decoder for efficient video compression.
The codec is optimised for fast encoding of large resolution video content while at the same time
preserving high perceptual qualities of the generated compressed video streams.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
sed -e 's/__SOVERSION__/%{_somaj}/' \
    -e 's/__VERSION__/%{_sover}/' \
    -i turing/CMakeLists.txt havoc/CMakeLists.txt

%build
%cmake -DUSE_SYSTEM_BOOST=1 -DTURING_VERSION=%{version}
make %{?_smp_mflags}

%install
%cmake_install

%post   -n libhavoc%{_somaj} -p /sbin/ldconfig
%postun -n libhavoc%{_somaj} -p /sbin/ldconfig
%post   -n lib%{name}%{_somaj} -p /sbin/ldconfig
%postun -n lib%{name}%{_somaj} -p /sbin/ldconfig

%files
%doc README.md
%license COPYING
%{_bindir}/%{name}
%{_bindir}/havoc

%files devel
%{_includedir}/%{name}.h
%{_libdir}/libhavoc.so
%{_libdir}/lib%{name}.so
%{_libdir}/pkgconfig/lib%{name}.pc

%files -n libhavoc%{_somaj}
%{_libdir}/libhavoc.so.%{_somaj}*

%files -n lib%{name}%{_somaj}
%{_libdir}/lib%{name}.so.%{_somaj}*

%changelog
* Wed Jul  8 2020 fridrich.strba@bluewin.ch
- Fix build
  * add boost_system to the libraries to link with
  * disable lto, since the package does not link with it
* Sat Jul 28 2018 aloisio@gmx.com
- Added turing-no-return-in-nonvoid.patch to fix TW build
- Added turing-system-boost.patch to use system boost libraries
- Added turing-shared-libs.patch to produce shared and versioned
  libraries. Also added related subpackages.
- Spec cleanup
* Sat Jul  8 2017 neutrino8@opensuse.org
- Update to latest git master
* Wed Nov 30 2016 neutrino8@opensuse.org
- Update to latest git master
* Fri Oct 28 2016 neutrino8@gmail.com
- Initial package
